# Project

open class Project : XmlPersistableConfigurationObject

Represents the customizable elements of an ipr (via XML hooks everything of the ipr is customizable).

## Constructors

Project
Link copied to clipboard
constructor(xmlTransformer: XmlTransformer, pathFactory: Any)

## Properties

jdk
Link copied to clipboard
open var jdk: Jdk
modulePaths
Link copied to clipboard
open var modulePaths: Set<Path>
projectLibraries
Link copied to clipboard
open var projectLibraries: Set<ProjectLibrary>
vcs
Link copied to clipboard
open var vcs: String
wildcards
Link copied to clipboard
open var wildcards: Set<String>
xml
Link copied to clipboard
open val xml: Node

## Functions

addModulePath
Link copied to clipboard
open fun addModulePath(moduleFile: File)
Adds a module to the module paths included in the Project.
configure
Link copied to clipboard
open fun configure(modules: List<IdeaModule>, jdkName: String, languageLevel: IdeaLanguageLevel, bytecodeVersion: JavaVersion, wildcards: Collection<String>, projectLibraries: Collection<ProjectLibrary>, vcs: String)
equals
Link copied to clipboard
open fun equals(o: Any): Boolean
findFirstChildNamed
Link copied to clipboard
open fun findFirstChildNamed(root: @Nullable Node, name: String): @Nullable Node
findFirstChildWithAttributeValue
Link copied to clipboard
open fun findFirstChildWithAttributeValue(root: @Nullable Node, childName: String, attribute: String, value: String): @Nullable Node
findOrCreateFirstChildNamed
Link copied to clipboard
open fun findOrCreateFirstChildNamed(root: Node, name: String): Node
findOrCreateFirstChildWithAttributeValue
Link copied to clipboard
open fun findOrCreateFirstChildWithAttributeValue(root: @Nullable Node, childName: String, attribute: String, value: String): Node
hashCode
Link copied to clipboard
open fun hashCode(): Int
load
Link copied to clipboard
open fun load(inputStream: InputStream)
loadDefaults
Link copied to clipboard
open fun loadDefaults()
store
Link copied to clipboard
open fun store(outputStream: OutputStream)
transformAction
Link copied to clipboard
open fun transformAction(action: Closure)